
import java.awt.*;
import java.io.Serializable;
/**
 * The Ship Class is how BattleShips represents ships 
 * Is designed to be subclassed and is used to set the basic operations a ship must be able to do
 * including implementing behavior that is the same for all ships
 * @author James Brunskill 0125699
 */

public class Ship implements Serializable, ShipInterface{
    /**
     * int to hold the X location of the ship 
     */
    protected int locX;
    /**
     * int to hold the Y location of the ship
     */
    protected int locY;
    /**
     * boolean to say whether or not the ship is facing North-South
     */
    protected boolean nS;


    /**
     * int to hold the length of the ship
     */
    protected int length;

    /**
     * Creates a new ship of length len, faceing direction specified by northS, and at location x,y
     */
    public Ship (int x, int y, boolean northS,int len)
    {
	locX = x;
	locY = y;
	nS = northS;
	length = len;
    }
	
    /**
     * Returns the x location of the ship
     */
    public int x ()
    { return locX; }
    /**
     * Returns the y location of the ship
     */
    public int y ()
    { return locY; }
	
    /**
     * Returns the nS boolean (whether the ship is facing north or east) 
     */
    public boolean NS()
    {return nS;}

    /**
     * sets the x and y location of the ship
     */
    public void setLoc(int x, int y)
    {
	locX = x;
	locY = y;
    }
    
    /**
     * Sets the nS field to the value passed in
     * The nS field is stands for north-South and is true if the ships runs verical up the screen
     */
    public void setNS(boolean ns)
    {
	nS = ns;
	
    }


    /**
     * doesn't do anything yet, is just there so that it implements the ShipInterface
     */
    public void paint (Graphics g)
    {
	//	System.out.println("You Should Never See this");
	
    }

}














