
import java.awt.*;
import java.io.Serializable;

/**
 * A square is little more than a square on the screen, but also holds information about whether a ship is int the square and what color it should be
 * it is designed to be used in side the board class
 * draws its self at the specified position
 * @author James Brunskill 0125699
 */

public class Square implements Serializable{
    /**
     * int to hold the X location of the square
     */
    protected int locX;
    /**
     * int to hold the Y location of the square
     */
    protected int locY;

    /**
     * Color to fill the middle of the square
     */
    protected Color color;

    /**
     * int to hold the size of the square
     */
    protected int size;

    /**
     * bool to specify whether there is a ship in the square
     */
    protected boolean containsShip;


    /**
     * bool to specify whether the square has been fired upon
     */
    protected boolean hit;



   
  /**
     * Creates a new square at location x,y and size of s
     * Also sets background color to white and the hit and containsShip fields to false
     */	
    public Square (int x, int y, int s)
    {
	locX = x;
	locY = y;
	size = s;
	color = Color.white;
	hit = false;
	containsShip = false;
    }
	
      /**
     * Returns the x location of the square
     */
    public int x ()
    { return locX;}
	
    /**
     * Returns the y location of the square
     */
    public int y ()
    { return locY;}

    /**
     * sets the ContainsShip field to true
     */
    public void setContainsShip()
    {
	containsShip = true;
    }
    /**
     *Returns the containsShip boolean
     */
    public boolean containsShip()
    {
	return containsShip;
    }

    /**
     * Returns whether this square has been fired upon
     */
    public boolean hasBeenHit()
    {

	return hit;
    }

    /**
     * returns true if the square contains a ship and sets the hit field to true
     * also sets background color
     */
    public boolean hit()
    {
	hit = true;

	if(containsShip)
	    {
		color = Color.red;
		return true;
	    }

	color = Color.blue;
	return false;
    }
  
    /**
     * Paints the square at location locX,locY and the background with Color color
     */
    public void paint (Graphics g)
    {
	g.setColor(color);
	g.fillRect(locX, locY, size, size); 
	g.setColor(Color.black);
	g.drawRect(locX, locY, size, size); 
                  
    }





}










